%define url_ver %{lua: ver = rpm.expand("%{version}"); majmin, count1 = string.gsub(ver, "^([0123456789]+%.[0123456789]+).*", "%1", 1); if count1 == 0 then print(ver); return; end; maj, count2 = string.gsub(majmin, "^([0123456789]+).*", "%1", 1); if count2 == 0 then print(majmin) elseif tonumber(majmin) < 40 then print(majmin) else print(maj) end}

%define api_version	1
%define major		1
%define libname		%mklibname dex %{api_version} %{major}
%define girname		%mklibname dex-gir %{api_version}
%define develname	%mklibname dex -d

Name:		libdex
Version:	0.7.0
Release:	%mkrel 1
Summary:	A library supporting "Deferred Execution" for GNOME and GTK
Group:		System/Libraries
License:	LGPL-2.1-or-later
URL:		https://gitlab.gnome.org/GNOME/libdex
Source0:	https://download.gnome.org/sources/libdex/%{url_ver}/%{name}-%{version}.tar.xz

BuildRequires:	meson
BuildRequires:	gi-docgen
BuildRequires:	libatomic-devel
BuildRequires:	pkgconfig(vapigen)
BuildRequires:	pkgconfig(gio-2.0)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(liburing)
BuildRequires:	pkgconfig(sysprof-capture-4)

%description
Dex is a library supporting "Deferred Execution" with the explicit goal
of integrating with GNOME and GTK-based applications.
It provides primatives for supporting futures in a variety of ways with both
read-only and writable views. Additionally, integration with existing
asynchronous-based APIs is provided through the use of wrapper promises.
"Fibers" are implemented which allows for writing synchronous looking code
which calls asynchronous APIs from GIO underneath.

#------------------------------------------------

%package -n	%{libname}
Summary:	A library supporting "Deferred Execution" for GNOME and GTK
Group:		System/Libraries

%description -n	%{libname}
Dex is a library supporting "Deferred Execution" with the explicit goal
of integrating with GNOME and GTK-based applications.
It provides primatives for supporting futures in a variety of ways with both
read-only and writable views. Additionally, integration with existing
asynchronous-based APIs is provided through the use of wrapper promises.
"Fibers" are implemented which allows for writing synchronous looking code
which calls asynchronous APIs from GIO underneath.

#------------------------------------------------

%package -n	%{girname}
Summary:	GObject Introspection interface description for Dex
Group:		System/Libraries
Requires:	%{libname} = %{version}-%{release}

%description -n	%{girname}
GObject Introspection interface description for Dex.

#------------------------------------------------

%package -n	%{develname}
Summary:	Development package for %{name}
Group:		Development/C++
Requires:	%{libname} = %{version}-%{release}
Requires:	%{girname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	%{name}-%{api_version}-devel = %{version}-%{release}
Provides:	dex-devel = %{version}-%{release}

%description -n	%{develname}
Header files for development with %{name}.

#------------------------------------------------

%prep
%autosetup -p1

%build
%meson \
  -Ddocs=true \
  -Dexamples=false \
  -Dsysprof=true
%meson_build

%install
%meson_install

%files -n %{libname}
%license COPYING
%doc NEWS README.md
%{_libdir}/libdex-%{api_version}.so.%{major}{,.*}

%files -n %{girname}
%doc README.md
%{_libdir}/girepository-1.0/Dex-%{api_version}.typelib

%files -n %{develname}
%doc README.md
%doc %{_docdir}/libdex-%{api_version}/
%{_includedir}/libdex-%{api_version}/
%{_libdir}/libdex-%{api_version}.so
%{_libdir}/pkgconfig/libdex-%{api_version}.pc
%{_datadir}/gir-1.0/Dex-%{api_version}.gir
%{_datadir}/vala/vapi/libdex-%{api_version}.deps
%{_datadir}/vala/vapi/libdex-%{api_version}.vapi


%changelog
* Tue Jul 02 2024 daviddavid <daviddavid> 0.7.0-1.mga10
+ Revision: 2078768
- new version: 0.7.0

* Sun Jun 02 2024 daviddavid <daviddavid> 0.6.1-1.mga10
+ Revision: 2069161
- new version 0.6.1

* Sun Mar 17 2024 daviddavid <daviddavid> 0.6.0-1.mga10
+ Revision: 2050151
- new version 0.6.0

* Mon Mar 04 2024 daviddavid <daviddavid> 0.5.1-1.mga10
+ Revision: 2047505
- new version 0.5.1

* Tue Feb 13 2024 daviddavid <daviddavid> 0.5.0-1.mga10
+ Revision: 2040817
- new version: 0.5.0

* Sat Jan 13 2024 daviddavid <daviddavid> 0.4.3-1.mga10
+ Revision: 2030858
- new version: 0.4.3

* Wed Oct 25 2023 daviddavid <daviddavid> 0.4.1-1.mga10
+ Revision: 2001164
- new version 0.4.1

* Wed Sep 20 2023 daviddavid <daviddavid> 0.4.0-1.mga10
+ Revision: 1988465
- new version: 0.4.0

* Tue Aug 29 2023 daviddavid <daviddavid> 0.3.1-1.mga10
+ Revision: 1980772
- new version 0.3.1

* Sun Apr 23 2023 daviddavid <daviddavid> 0.2.0-2.mga9
+ Revision: 1954338
- initial package libdex

